using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.PaymentDisburse.Cqrs;

public record DeletePaymentDisburseByIdCommand(string Id) : IRequest<bool>;

public class DeletePaymentDisburseByIdHandler : IRequestHandler<DeletePaymentDisburseByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeletePaymentDisburseByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeletePaymentDisburseByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.PaymentDisburse
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.PaymentDisburse.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}